use axum::{routing::get, Router};
use ractor::{Actor, ActorProcessingErr, ActorRef};
use tokio::sync::oneshot;

#[tokio::main]
async fn main() {
    let (gay_actor, _gay_handle) = Actor::spawn(None, GayGayMeowGay, ()).await.unwrap();
    let (_actor, handle) = Actor::spawn(None, HttpRouter, vec![gay_actor])
        .await
        .unwrap();
    handle.await.unwrap();
}

struct HttpRouter;

enum Req {
    Get(oneshot::Sender<String>),
}

#[async_trait::async_trait]
impl Actor for HttpRouter {
    type Msg = ();
    type State = ();
    type Arguments = Vec<ActorRef<Req>>;

    async fn pre_start(
        &self,
        _myself: ActorRef<Self::Msg>,
        args: Self::Arguments,
    ) -> Result<Self::State, ActorProcessingErr> {
        let handler = move || {
            let (tx, rx) = oneshot::channel();
            args[0].clone().send_message(Req::Get(tx)).unwrap();
            async { rx.await.unwrap() }
        };
        let router = Router::new().route("/", get(handler));
        let _handle = tokio::spawn(
            axum::Server::bind(&"0.0.0.0:8080".parse().unwrap()).serve(router.into_make_service()),
        );
        Ok(())
    }
}

struct GayGayMeowGay;

#[async_trait::async_trait]
impl Actor for GayGayMeowGay {
    type Msg = Req;
    type State = u32;
    type Arguments = ();

    async fn pre_start(
        &self,
        _myself: ActorRef<Self::Msg>,
        _args: Self::Arguments,
    ) -> Result<Self::State, ActorProcessingErr> {
        Ok(0)
    }

    async fn handle(
        &self,
        _myself: ActorRef<Self::Msg>,
        message: Self::Msg,
        state: &mut Self::State,
    ) -> Result<(), ActorProcessingErr> {
        *state += 1;
        println!("gays: {state}");

        match message {
            Req::Get(responder) => responder.send("gay gay meow gay :3".to_string()).unwrap(),
        };

        Ok(())
    }
}
